diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/wifi-mac.cc ns-3.36/src/wifi/model/wifi-mac.cc
--- ns-3.35/src/wifi/model/wifi-mac.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/wifi-mac.cc	2022-04-30 18:23:58.214735300 -0700
@@ -19,14 +19,22 @@
  */
 
 #include "ns3/log.h"
+#include "ns3/pointer.h"
 #include "ns3/packet.h"
 #include "wifi-mac.h"
-#include "txop.h"
+#include "qos-txop.h"
 #include "ssid.h"
+#include "mgt-headers.h"
 #include "wifi-net-device.h"
+#include "wifi-mac-queue.h"
+#include "mac-rx-middle.h"
+#include "mac-tx-middle.h"
+#include "channel-access-manager.h"
 #include "ns3/ht-configuration.h"
 #include "ns3/vht-configuration.h"
 #include "ns3/he-configuration.h"
+#include "ns3/he-frame-exchange-manager.h"
+#include "extended-capabilities.h"
 
 namespace ns3 {
 
@@ -34,6 +42,26 @@
 
 NS_OBJECT_ENSURE_REGISTERED (WifiMac);
 
+WifiMac::WifiMac ()
+  : m_qosSupported (false),
+    m_erpSupported (false),
+    m_dsssSupported (false)
+{
+  NS_LOG_FUNCTION (this);
+
+  m_rxMiddle = Create<MacRxMiddle> ();
+  m_rxMiddle->SetForwardCallback (MakeCallback (&WifiMac::Receive, this));
+
+  m_txMiddle = Create<MacTxMiddle> ();
+
+  m_channelAccessManager = CreateObject<ChannelAccessManager> ();
+}
+
+WifiMac::~WifiMac ()
+{
+  NS_LOG_FUNCTION (this);
+}
+
 TypeId
 WifiMac::GetTypeId (void)
 {
@@ -45,6 +73,165 @@
                    MakeSsidAccessor (&WifiMac::GetSsid,
                                      &WifiMac::SetSsid),
                    MakeSsidChecker ())
+    .AddAttribute ("QosSupported",
+                   "This Boolean attribute is set to enable 802.11e/WMM-style QoS support at this STA.",
+                   TypeId::ATTR_GET | TypeId::ATTR_CONSTRUCT,  // prevent setting after construction
+                   BooleanValue (false),
+                   MakeBooleanAccessor (&WifiMac::SetQosSupported,
+                                        &WifiMac::GetQosSupported),
+                   MakeBooleanChecker ())
+    .AddAttribute ("CtsToSelfSupported",
+                   "Use CTS to Self when using a rate that is not in the basic rate set.",
+                   BooleanValue (false),
+                   MakeBooleanAccessor (&WifiMac::SetCtsToSelfSupported),
+                   MakeBooleanChecker ())
+    .AddAttribute ("ShortSlotTimeSupported",
+                   "Whether or not short slot time is supported (only used by ERP APs or STAs).",
+                   BooleanValue (true),
+                   MakeBooleanAccessor (&WifiMac::SetShortSlotTimeSupported,
+                                        &WifiMac::GetShortSlotTimeSupported),
+                   MakeBooleanChecker ())
+    .AddAttribute ("Txop",
+                   "The Txop object.",
+                   PointerValue (),
+                   MakePointerAccessor (&WifiMac::GetTxop),
+                   MakePointerChecker<Txop> ())
+    .AddAttribute ("VO_Txop",
+                   "Queue that manages packets belonging to AC_VO access class.",
+                   PointerValue (),
+                   MakePointerAccessor (&WifiMac::GetVOQueue),
+                   MakePointerChecker<QosTxop> ())
+    .AddAttribute ("VI_Txop",
+                   "Queue that manages packets belonging to AC_VI access class.",
+                   PointerValue (),
+                   MakePointerAccessor (&WifiMac::GetVIQueue),
+                   MakePointerChecker<QosTxop> ())
+    .AddAttribute ("BE_Txop",
+                   "Queue that manages packets belonging to AC_BE access class.",
+                   PointerValue (),
+                   MakePointerAccessor (&WifiMac::GetBEQueue),
+                   MakePointerChecker<QosTxop> ())
+    .AddAttribute ("BK_Txop",
+                   "Queue that manages packets belonging to AC_BK access class.",
+                   PointerValue (),
+                   MakePointerAccessor (&WifiMac::GetBKQueue),
+                   MakePointerChecker<QosTxop> ())
+    .AddAttribute ("VO_MaxAmsduSize",
+                   "Maximum length in bytes of an A-MSDU for AC_VO access class "
+                   "(capped to 7935 for HT PPDUs and 11398 for VHT/HE PPDUs). "
+                   "Value 0 means A-MSDU aggregation is disabled for that AC.",
+                   UintegerValue (0),
+                   MakeUintegerAccessor (&WifiMac::m_voMaxAmsduSize),
+                   MakeUintegerChecker<uint16_t> (0, 11398))
+    .AddAttribute ("VI_MaxAmsduSize",
+                   "Maximum length in bytes of an A-MSDU for AC_VI access class "
+                   "(capped to 7935 for HT PPDUs and 11398 for VHT/HE PPDUs). "
+                   "Value 0 means A-MSDU aggregation is disabled for that AC.",
+                   UintegerValue (0),
+                   MakeUintegerAccessor (&WifiMac::m_viMaxAmsduSize),
+                   MakeUintegerChecker<uint16_t> (0, 11398))
+    .AddAttribute ("BE_MaxAmsduSize",
+                   "Maximum length in bytes of an A-MSDU for AC_BE access class "
+                   "(capped to 7935 for HT PPDUs and 11398 for VHT/HE PPDUs). "
+                   "Value 0 means A-MSDU aggregation is disabled for that AC.",
+                   UintegerValue (0),
+                   MakeUintegerAccessor (&WifiMac::m_beMaxAmsduSize),
+                   MakeUintegerChecker<uint16_t> (0, 11398))
+    .AddAttribute ("BK_MaxAmsduSize",
+                   "Maximum length in bytes of an A-MSDU for AC_BK access class "
+                   "(capped to 7935 for HT PPDUs and 11398 for VHT/HE PPDUs). "
+                   "Value 0 means A-MSDU aggregation is disabled for that AC.",
+                   UintegerValue (0),
+                   MakeUintegerAccessor (&WifiMac::m_bkMaxAmsduSize),
+                   MakeUintegerChecker<uint16_t> (0, 11398))
+    .AddAttribute ("VO_MaxAmpduSize",
+                   "Maximum length in bytes of an A-MPDU for AC_VO access class "
+                   "(capped to 65535 for HT PPDUs, 1048575 for VHT PPDUs, and 6500631 for HE PPDUs). "
+                   "Value 0 means A-MPDU aggregation is disabled for that AC.",
+                   UintegerValue (0),
+                   MakeUintegerAccessor (&WifiMac::m_voMaxAmpduSize),
+                   MakeUintegerChecker<uint32_t> (0, 6500631))
+    .AddAttribute ("VI_MaxAmpduSize",
+                   "Maximum length in bytes of an A-MPDU for AC_VI access class "
+                   "(capped to 65535 for HT PPDUs, 1048575 for VHT PPDUs, and 6500631 for HE PPDUs). "
+                   "Value 0 means A-MPDU aggregation is disabled for that AC.",
+                   UintegerValue (65535),
+                   MakeUintegerAccessor (&WifiMac::m_viMaxAmpduSize),
+                   MakeUintegerChecker<uint32_t> (0, 6500631))
+    .AddAttribute ("BE_MaxAmpduSize",
+                   "Maximum length in bytes of an A-MPDU for AC_BE access class "
+                   "(capped to 65535 for HT PPDUs, 1048575 for VHT PPDUs, and 6500631 for HE PPDUs). "
+                   "Value 0 means A-MPDU aggregation is disabled for that AC.",
+                   UintegerValue (65535),
+                   MakeUintegerAccessor (&WifiMac::m_beMaxAmpduSize),
+                   MakeUintegerChecker<uint32_t> (0, 6500631))
+    .AddAttribute ("BK_MaxAmpduSize",
+                   "Maximum length in bytes of an A-MPDU for AC_BK access class "
+                   "(capped to 65535 for HT PPDUs, 1048575 for VHT PPDUs, and 6500631 for HE PPDUs). "
+                   "Value 0 means A-MPDU aggregation is disabled for that AC.",
+                   UintegerValue (0),
+                   MakeUintegerAccessor (&WifiMac::m_bkMaxAmpduSize),
+                   MakeUintegerChecker<uint32_t> (0, 6500631))
+    .AddAttribute ("VO_BlockAckThreshold",
+                   "If number of packets in VO queue reaches this value, "
+                   "block ack mechanism is used. If this value is 0, block ack is never used."
+                   "When A-MPDU is enabled, block ack mechanism is used regardless of this value.",
+                   UintegerValue (0),
+                   MakeUintegerAccessor (&WifiMac::SetVoBlockAckThreshold),
+                   MakeUintegerChecker<uint8_t> (0, 64))
+    .AddAttribute ("VI_BlockAckThreshold",
+                   "If number of packets in VI queue reaches this value, "
+                   "block ack mechanism is used. If this value is 0, block ack is never used."
+                   "When A-MPDU is enabled, block ack mechanism is used regardless of this value.",
+                   UintegerValue (0),
+                   MakeUintegerAccessor (&WifiMac::SetViBlockAckThreshold),
+                   MakeUintegerChecker<uint8_t> (0, 64))
+    .AddAttribute ("BE_BlockAckThreshold",
+                   "If number of packets in BE queue reaches this value, "
+                   "block ack mechanism is used. If this value is 0, block ack is never used."
+                   "When A-MPDU is enabled, block ack mechanism is used regardless of this value.",
+                   UintegerValue (0),
+                   MakeUintegerAccessor (&WifiMac::SetBeBlockAckThreshold),
+                   MakeUintegerChecker<uint8_t> (0, 64))
+    .AddAttribute ("BK_BlockAckThreshold",
+                   "If number of packets in BK queue reaches this value, "
+                   "block ack mechanism is used. If this value is 0, block ack is never used."
+                   "When A-MPDU is enabled, block ack mechanism is used regardless of this value.",
+                   UintegerValue (0),
+                   MakeUintegerAccessor (&WifiMac::SetBkBlockAckThreshold),
+                   MakeUintegerChecker<uint8_t> (0, 64))
+    .AddAttribute ("VO_BlockAckInactivityTimeout",
+                   "Represents max time (blocks of 1024 microseconds) allowed for block ack"
+                   "inactivity for AC_VO. If this value isn't equal to 0 a timer start after that a"
+                   "block ack setup is completed and will be reset every time that a block ack"
+                   "frame is received. If this value is 0, block ack inactivity timeout won't be used.",
+                   UintegerValue (0),
+                   MakeUintegerAccessor (&WifiMac::SetVoBlockAckInactivityTimeout),
+                   MakeUintegerChecker<uint16_t> ())
+    .AddAttribute ("VI_BlockAckInactivityTimeout",
+                   "Represents max time (blocks of 1024 microseconds) allowed for block ack"
+                   "inactivity for AC_VI. If this value isn't equal to 0 a timer start after that a"
+                   "block ack setup is completed and will be reset every time that a block ack"
+                   "frame is received. If this value is 0, block ack inactivity timeout won't be used.",
+                   UintegerValue (0),
+                   MakeUintegerAccessor (&WifiMac::SetViBlockAckInactivityTimeout),
+                   MakeUintegerChecker<uint16_t> ())
+    .AddAttribute ("BE_BlockAckInactivityTimeout",
+                   "Represents max time (blocks of 1024 microseconds) allowed for block ack"
+                   "inactivity for AC_BE. If this value isn't equal to 0 a timer start after that a"
+                   "block ack setup is completed and will be reset every time that a block ack"
+                   "frame is received. If this value is 0, block ack inactivity timeout won't be used.",
+                   UintegerValue (0),
+                   MakeUintegerAccessor (&WifiMac::SetBeBlockAckInactivityTimeout),
+                   MakeUintegerChecker<uint16_t> ())
+    .AddAttribute ("BK_BlockAckInactivityTimeout",
+                   "Represents max time (blocks of 1024 microseconds) allowed for block ack"
+                   "inactivity for AC_BK. If this value isn't equal to 0 a timer start after that a"
+                   "block ack setup is completed and will be reset every time that a block ack"
+                   "frame is received. If this value is 0, block ack inactivity timeout won't be used.",
+                   UintegerValue (0),
+                   MakeUintegerAccessor (&WifiMac::SetBkBlockAckInactivityTimeout),
+                   MakeUintegerChecker<uint16_t> ())
     .AddTraceSource ("MacTx",
                      "A packet has been received from higher layers and is being processed in preparation for "
                      "queueing for transmission.",
@@ -71,29 +258,264 @@
                      "A packet has been dropped in the MAC layer after it has been passed up from the physical layer.",
                      MakeTraceSourceAccessor (&WifiMac::m_macRxDropTrace),
                      "ns3::Packet::TracedCallback")
+    .AddTraceSource ("TxOkHeader",
+                     "The header of successfully transmitted packet.",
+                     MakeTraceSourceAccessor (&WifiMac::m_txOkCallback),
+                     "ns3::WifiMacHeader::TracedCallback",
+                     TypeId::OBSOLETE,
+                     "Use the AckedMpdu trace instead.")
+    .AddTraceSource ("TxErrHeader",
+                     "The header of unsuccessfully transmitted packet.",
+                     MakeTraceSourceAccessor (&WifiMac::m_txErrCallback),
+                     "ns3::WifiMacHeader::TracedCallback",
+                     TypeId::OBSOLETE,
+                     "Depending on the failure type, use the NAckedMpdu trace, the "
+                     "DroppedMpdu trace or one of the traces associated with TX timeouts.")
+    .AddTraceSource ("AckedMpdu",
+                     "An MPDU that was successfully acknowledged, via either a "
+                     "Normal Ack or a Block Ack.",
+                     MakeTraceSourceAccessor (&WifiMac::m_ackedMpduCallback),
+                     "ns3::WifiMacQueueItem::TracedCallback")
+    .AddTraceSource ("NAckedMpdu",
+                     "An MPDU that was negatively acknowledged via a Block Ack.",
+                     MakeTraceSourceAccessor (&WifiMac::m_nackedMpduCallback),
+                     "ns3::WifiMacQueueItem::TracedCallback")
+    .AddTraceSource ("DroppedMpdu",
+                     "An MPDU that was dropped for the given reason (see WifiMacDropReason).",
+                     MakeTraceSourceAccessor (&WifiMac::m_droppedMpduCallback),
+                     "ns3::WifiMac::DroppedMpduCallback")
+    .AddTraceSource ("MpduResponseTimeout",
+                     "An MPDU whose response was not received before the timeout, along with "
+                     "an identifier of the type of timeout (see WifiTxTimer::Reason) and the "
+                     "TXVECTOR used to transmit the MPDU. This trace source is fired when a "
+                     "CTS is missing after an RTS or a Normal Ack is missing after an MPDU "
+                     "or after a DL MU PPDU acknowledged in SU format.",
+                     MakeTraceSourceAccessor (&WifiMac::m_mpduResponseTimeoutCallback),
+                     "ns3::WifiMac::MpduResponseTimeoutCallback")
+    .AddTraceSource ("PsduResponseTimeout",
+                     "A PSDU whose response was not received before the timeout, along with "
+                     "an identifier of the type of timeout (see WifiTxTimer::Reason) and the "
+                     "TXVECTOR used to transmit the PSDU. This trace source is fired when a "
+                     "BlockAck is missing after an A-MPDU, a BlockAckReq (possibly in the "
+                     "context of the acknowledgment of a DL MU PPDU in SU format) or a TB PPDU "
+                     "(in the latter case the missing BlockAck is a Multi-STA BlockAck).",
+                     MakeTraceSourceAccessor (&WifiMac::m_psduResponseTimeoutCallback),
+                     "ns3::WifiMac::PsduResponseTimeoutCallback")
+    .AddTraceSource ("PsduMapResponseTimeout",
+                     "A PSDU map for which not all the responses were received before the timeout, "
+                     "along with an identifier of the type of timeout (see WifiTxTimer::Reason), "
+                     "the set of MAC addresses of the stations that did not respond and the total "
+                     "number of stations that had to respond. This trace source is fired when not "
+                     "all the addressed stations responded to an MU-BAR Trigger frame (either sent as "
+                     "a SU frame or aggregated to PSDUs in the DL MU PPDU), a Basic Trigger Frame or "
+                     "a BSRP Trigger Frame.",
+                     MakeTraceSourceAccessor (&WifiMac::m_psduMapResponseTimeoutCallback),
+                     "ns3::WifiMac::PsduMapResponseTimeoutCallback")
   ;
   return tid;
 }
 
+
+void
+WifiMac::DoInitialize ()
+{
+  NS_LOG_FUNCTION (this);
+
+  if (m_txop != nullptr)
+    {
+      m_txop->Initialize ();
+    }
+
+  for (auto it = m_edca.begin (); it != m_edca.end (); ++it)
+    {
+      it->second->Initialize ();
+    }
+}
+
 void
 WifiMac::DoDispose ()
 {
+  NS_LOG_FUNCTION (this);
+
+  m_rxMiddle = 0;
+  m_txMiddle = 0;
+
+  m_channelAccessManager->Dispose ();
+  m_channelAccessManager = 0;
+
+  if (m_txop != nullptr)
+    {
+      m_txop->Dispose ();
+    }
+  m_txop = 0;
+
+  for (auto it = m_edca.begin (); it != m_edca.end (); ++it)
+    {
+      it->second->Dispose ();
+      it->second = 0;
+    }
+
+  if (m_feManager != 0)
+    {
+      m_feManager->Dispose ();
+    }
+  m_feManager = 0;
+
+  m_stationManager = 0;
+  m_phy = 0;
+
   m_device = 0;
 }
 
 void
-WifiMac::SetDevice (const Ptr<NetDevice> device)
+WifiMac::SetTypeOfStation (TypeOfStation type)
+{
+  NS_LOG_FUNCTION (this << type);
+  m_typeOfStation = type;
+}
+
+TypeOfStation
+WifiMac::GetTypeOfStation (void) const
+{
+  return m_typeOfStation;
+}
+
+void
+WifiMac::SetDevice (const Ptr<WifiNetDevice> device)
 {
   m_device = device;
 }
 
-Ptr<NetDevice>
+Ptr<WifiNetDevice>
 WifiMac::GetDevice (void) const
 {
   return m_device;
 }
 
 void
+WifiMac::SetAddress (Mac48Address address)
+{
+  NS_LOG_FUNCTION (this << address);
+  m_address = address;
+}
+
+Mac48Address
+WifiMac::GetAddress (void) const
+{
+  return m_address;
+}
+
+void
+WifiMac::SetSsid (Ssid ssid)
+{
+  NS_LOG_FUNCTION (this << ssid);
+  m_ssid = ssid;
+}
+
+Ssid
+WifiMac::GetSsid (void) const
+{
+  return m_ssid;
+}
+
+void
+WifiMac::SetBssid (Mac48Address bssid)
+{
+  NS_LOG_FUNCTION (this << bssid);
+  m_bssid = bssid;
+  if (m_feManager)
+    {
+      m_feManager->SetBssid (bssid);
+    }
+}
+
+Mac48Address
+WifiMac::GetBssid (void) const
+{
+  return m_bssid;
+}
+
+void
+WifiMac::SetPromisc (void)
+{
+  NS_ASSERT (m_feManager != 0);
+  m_feManager->SetPromisc ();
+}
+
+Ptr<Txop>
+WifiMac::GetTxop () const
+{
+  return m_txop;
+}
+
+Ptr<QosTxop>
+WifiMac::GetQosTxop (AcIndex ac) const
+{
+  // Use std::find_if() instead of std::map::find() because the latter compares
+  // the given AC index with the AC index of an element in the map by using the
+  // operator< defined for AcIndex, which aborts if an operand is not a QoS AC
+  // (the AC index passed to this method may not be a QoS AC).
+  // The performance penalty is limited because std::map::find() performs 3
+  // comparisons in the worst case, while std::find_if() performs 4 comparisons
+  // in the worst case.
+  const auto it = std::find_if (m_edca.cbegin (), m_edca.cend (),
+                                [ac](const auto& pair){ return pair.first == ac; });
+  return (it == m_edca.cend () ? nullptr : it->second);
+}
+
+Ptr<QosTxop>
+WifiMac::GetQosTxop (uint8_t tid) const
+{
+  return GetQosTxop (QosUtilsMapTidToAc (tid));
+}
+
+Ptr<QosTxop>
+WifiMac::GetVOQueue () const
+{
+  return (m_qosSupported ? GetQosTxop (AC_VO) : nullptr);
+}
+
+Ptr<QosTxop>
+WifiMac::GetVIQueue () const
+{
+  return (m_qosSupported ? GetQosTxop (AC_VI) : nullptr);
+}
+
+Ptr<QosTxop>
+WifiMac::GetBEQueue () const
+{
+  return (m_qosSupported ? GetQosTxop (AC_BE) : nullptr);
+}
+
+Ptr<QosTxop>
+WifiMac::GetBKQueue () const
+{
+  return (m_qosSupported ? GetQosTxop (AC_BK) : nullptr);
+}
+
+Ptr<WifiMacQueue>
+WifiMac::GetTxopQueue (AcIndex ac) const
+{
+  Ptr<Txop> txop = (ac == AC_BE_NQOS ? m_txop : StaticCast<Txop> (GetQosTxop (ac)));
+  return (txop != nullptr ? txop->GetWifiMacQueue () : nullptr);
+}
+
+void
+WifiMac::NotifyChannelSwitching (void)
+{
+  NS_LOG_FUNCTION (this);
+
+  // we may have changed PHY band, in which case it is necessary to re-configure
+  // the PHY dependent parameters. In any case, this makes no harm
+  ConfigurePhyDependentParameters ();
+
+  // SetupPhy not only resets the remote station manager, but also sets the
+  // default TX mode and MCS, which is required when switching to a channel
+  // in a different band
+  m_stationManager->SetupPhy (m_phy);
+}
+
+void
 WifiMac::NotifyTx (Ptr<const Packet> packet)
 {
   m_macTxTrace (packet);
@@ -124,9 +546,50 @@
 }
 
 void
+WifiMac::SetupEdcaQueue (AcIndex ac)
+{
+  NS_LOG_FUNCTION (this << ac);
+
+  //Our caller shouldn't be attempting to setup a queue that is
+  //already configured.
+  NS_ASSERT (m_edca.find (ac) == m_edca.end ());
+
+  Ptr<QosTxop> edca = CreateObject<QosTxop> (ac);
+  edca->SetChannelAccessManager (m_channelAccessManager);
+  edca->SetWifiMac (this);
+  edca->SetTxMiddle (m_txMiddle);
+  edca->GetBaManager ()->SetTxOkCallback (MakeCallback (&MpduTracedCallback::operator(),
+                                                        &m_ackedMpduCallback));
+  edca->GetBaManager ()->SetTxFailedCallback (MakeCallback (&MpduTracedCallback::operator(),
+                                                            &m_nackedMpduCallback));
+  edca->SetDroppedMpduCallback (MakeCallback (&DroppedMpduTracedCallback::operator(),
+                                              &m_droppedMpduCallback));
+
+  m_edca.insert (std::make_pair (ac, edca));
+}
+
+void
+WifiMac::ConfigureContentionWindow (uint32_t cwMin, uint32_t cwMax)
+{
+  bool isDsssOnly = GetDsssSupported () && !GetErpSupported ();
+  if (m_txop != nullptr)
+    {
+      //The special value of AC_BE_NQOS which exists in the Access
+      //Category enumeration allows us to configure plain old DCF.
+      ConfigureDcf (m_txop, cwMin, cwMax, isDsssOnly, AC_BE_NQOS);
+    }
+
+  //Now we configure the EDCA functions
+  for (auto it = m_edca.begin (); it!= m_edca.end (); ++it)
+    {
+      ConfigureDcf (it->second, cwMin, cwMax, isDsssOnly, it->first);
+    }
+}
+
+void
 WifiMac::ConfigureDcf (Ptr<Txop> dcf, uint32_t cwmin, uint32_t cwmax, bool isDsss, AcIndex ac)
 {
-  NS_LOG_FUNCTION (this << dcf << cwmin << cwmax << isDsss << ac);
+  NS_LOG_FUNCTION (this << dcf << cwmin << cwmax << isDsss << +ac);
   /* see IEEE 802.11 section 7.3.2.29 */
   switch (ac)
     {
